***********************  TRM_QSIL.PRG  ****************************************
*
* This version runs under:  QuickSilver
* NOTE: The procedure file for this program is: QSILVER.PRC
*
*    >>>>                                                    <<<<
*    >  Modify line 87 BEFORE running this program so that your <
*    >    particular modem config is known to this program.     <
*    >>>>                                                    <<<<
*
*
* This is a sample program which demonstrates a number of the COMET library
* commands used to emulate a simple terminal program. You should code in the
* phone number you need dialed directly into this demo program.
* Good luck & have fun !!!
*
* Command keys defined:
*   F2 - Clears the screen
*   F3 - Send a file or group of files(if Ymodem specified for protocol)
*   F4 - Receive a file or files(if Ymodem)
*   ESC - Quits program
*******************************************************************************
*
SET TALK OFF
SET BELL OFF
SET STATUS OFF
SET ESCAPE ON
PUBLIC Event, LF, Msg, ChkCmd, Thresh, Fox, FoxPro, QS, LastMsg
PUBLIC AX, BX, CX, DX, IntNo        && For DOS calls
CLEAR
LOAD COMET                          && Loads COMET.BIN communications library
SET PROCEDURE TO QSILVER.PRC
ON ERROR DO ShutDown
ON ESCAPE DO GotAKey WITH 27        && 27 = INKEY() value of ESC key

* Display sign-on message
@ 5, 13 TO 13,65 DOUBLE
@ 7,15 SAY 'TERMINAL - A Terminal Emulation Program Using ...'
@ 9,35 SAY '- COMET -'
@ 11,15 SAY 'The  B A C K G R O U N D  Communication Library'
Msg = 'COPYRIGHT(c) 1989 by  CompuSolve,  Rockaway, NJ  (201)983-9429'
SET COLOR TO N/W
@24,0
@24,0 SAY Msg
SET COLOR TO W/N

* Wait loop
    Secs = 0
    LastTime = TIME()
    DO WHILE INKEY() = 0 .AND. Secs < 5
        IF LastTime <> TIME()
            Secs = Secs + 1
            LastTime = TIME()
        ENDIF
    ENDDO

CLEAR
Msg = 'Enter a telephone # to dial...'
SET COLOR TO N/W
@24,0
@24,0 SAY Msg
SET COLOR TO W/N
@0,0
* Init variables
ChkCmd = ''

* Function keys used to invoke local commands
F1 = 28
F2 = -1                             && Clear Screen
F3 = -2                             && Send file
F4 = -3                             && Receive file
F10 = -9
Up = 5
Dn = 24
Rgt = 4
Lft = 19
BkSpc = 127


SET FUNC 'F2' TO
SET FUNC 'F3' TO
SET FUNC 'F4' TO
SET FUNC 'F10' TO


* 1st, open up our COM port [Put YOUR COM port#, baud rate etc. in next line]
Open = "OPEN COM1:1200,N,8,1"       && Build COMET OPEN command into <expC>
CALL COMET WITH Open                && COM port now opened for use, that was easy!

* Now we'll dial a phone#
* Request # to dial 1st
PhoneNo = SPACE(20)
ACCEPT "Phone No. to Dial ?" TO PhoneNo

* The ATTD is output to instruct HAYES compatible modems to dial a #
Dial = "OUTPUT ATTD" + PhoneNo + CHR(13)  && Build OUTPUT command
CALL COMET WITH Dial                && Have modem dial #

Msg = 'Waiting for Carrier, Please Wait ...'
SET COLOR TO N/W
@24,0
@24,0 SAY Msg
SET COLOR TO W/N
* Now, wait till we sense Data Carrier Detect(DCD) from our COM port.
Elapsed = 0                         && Simple timer for our DO .. WHILE loop
LastTime = TIME()                   && Also used for timing purposes
MdmStat = "MSTAT " + SPACE(25)        && Build MSTAT command
DO WHILE Elapsed <= 45 .AND. (.NOT. "+DCD" $ MdmStat)
    CALL COMET WITH MdmStat         && Get COM port's modem status

    IF LastTime <> TIME()           && Test if we need to updated timer count
        Elapsed = Elapsed+1         && Another second has gone by ..
        LastTime = TIME()
        @ 24, 37 SAY STR(45-Elapsed,2,0)   && Display #secs till abort
    ENDIF
ENDDO

* Check if we timed out
IF Elapsed > 45
    ??CHR(7)
    Msg = "Sorry, can't establish phone connection. Aborting ..."
SET COLOR TO N/W
@24,0
@24,0 SAY Msg
SET COLOR TO W/N
    DO ShutDown
ENDIF

* Now that we have a call established we have 2 things to do:
*  1) Check COMET's receive buffer and display any incoming characters
*  2) Detect any keystrokes and determine if local command or data to output

* #2 is simple ... use an ON KEY approach
ON KEY DO GotAkey WITH INKEY()

* Clear initial screen after connect, set status message
Msg = "F2 - Clear | F3 - Send | F4 - Recv | TERM"
LastMsg = Msg
SET COLOR TO N/W
@24,0
@24,0 SAY Msg
SET COLOR TO W/N
@ 0,0 CLEAR TO 23,79
@ 0,0

***************************************************************************
* This is main loop for testing for and displaying any incoming data
DO WHILE .T.
    Term = CHR(10)          && Termination character = Line Feed
    Inp = "INPUT " + Term + SPACE(100)  && Build INPUT command
    CALL COMET WITH Inp   && Read COMET's COM port data buffer

    AmtRetd = VAL(SUBSTR(Inp,8,4))  && Determine how many chars were returned, if any
    COMactive = IIF(AmtRetd > 0, .T., .F.)
    ComData = SUBSTR(Inp, 12, AmtRetd)  && Get just the COM data from <expC>

* A loop to break down the COM data in order to deal with CR's & LF's
* This is a royal pain but need to do since we must not write to the last
* line (# 24). Line 24 is reseved as a help/status line.
        DO WHILE AmtRetd > 0
        CrAt = AT(CHR(13), ComData)     && Locate any CR's
        LfAt = AT(CHR(10), ComData)     && Locate any LF's
        DO CASE
            CASE CrAt > 0 .OR. LfAt > 0  && Print chars to left of a CR or LF for this pass
                NoToPrt = IIF(CrAt > 0, CrAt, LfAt) -1
                CRorLF = .T.
            OTHERWISE                   && No CR or LF, print as many as fit on current line
                NoToPrt = MIN(AmtRetd, 80-COL())
                CRorLF = .F.
        ENDCASE

        IF NoToPrt > 0                  && Print COM data (if any)
            @ ROW(), COL() SAY LEFT(ComData, NoToPrt)
            @ ROW(), COL()              && QS has a bug in that it doesn't position
                                        && cursor AFTER last character displayed
            IF COL() = 0                && Did we get auto-CR/LF by writing to column 80 ?
                @ROW()-1, 79 SAY ''     && If so, backup to end of previuos line
            ENDIF
        ENDIF

    * Remove any printed COM data & CR/LF's for next loop
        ComData = STUFF(ComData, 1, NoToPrt + IIF(CRorLF, 1, 0), '')
        AmtRetd = LEN(ComData)

    * Here's our logic to do scrolling at bottom and line feeds
        DO CASE
            CASE ROW() > 23 .OR. (ROW()>=23 .AND. CrAt > 0)
* Initialize vars for call to DOS INT 10h (video services), Service 6 (scroll)
IntNo = HTOI("10")
AX =    HTOI("0601")
BX =    HTOI("2000")
CX =    HTOI("0000")
DX =    HTOI("17F4")
                DOSINT 16, AX, BX, CX, DX       && Scroll up 1 line
                @ 23,0
            CASE CrAt > 0
                ?
        ENDCASE
     ENDDO
ENDDO                       && End of incoming data display loop
***************************************************************************




